<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api, api_key_tiny_editor } from "~/common/constaint";
import _, { cloneDeep } from "lodash";
@Component({})
export default class AdminUserSettingsPaymentComponent extends Vue {
  tab = 0;

  config = {
    page: 1,
    limit: 25,
    search: "",
    type: "",
  };
  page = 1;

  configPayment = {
    page: 1,
    limit: 25,
    search: "",
  };
  pagePayment = 1;
  totalPagePayment = 0;

  configStore = {
    page: 1,
    limit: 25,
    search: "",
    sellerId: "",
  };
  pageStore = 1;

  paymentId = "";
  listPaymentSeller = [
    {
      type: "paypal",
      name: "",
      _id: "",
    },
    {
      type: "stripe",
      name: "",
      _id: "",
    },
  ];
  sellerId = "";
  userPaymentId: any = {};
  sellerDetail = {};

  dialogAddPayment = false;
  dialogRemovePayment = false;
  loadingTable = false;
  loading = false;

  get listPayment() {
    const listPayment = cloneDeep(this.$store.state.adminPayment.listPayment);
    return listPayment || [];
  }

  get totalPage() {
    return this.$store.state.adminPayment.totalPage || 0;
  }

  get listStore() {
    const listStore = cloneDeep(this.$store.state.adminUsers.listStore) || [];
    return listStore;
  }

  get totalPageStore() {
    return this.$store.state.adminUsers.totalPageStore || [];
  }

  mounted() {
    this.sellerId = this.$route.params.id || "";
    if (this.sellerId) {
      this.onGetDetail();
      this.onGetListPaymentSeller();
      this.onGetListStore();
    }
  }

  async onGetDetail() {
    try {
      const response = await this.$api.userAdmin.sellerDetail(this.sellerId);
      if (response?.data) {
        this.sellerDetail = response.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async onGetListPayment() {
    this.$store.dispatch("adminPayment/onGetListPayment", {
      ctx: this,
      query: this.config,
    });
  }

  async onGetListPaymentSeller() {
    if (!this.sellerId) {
      return this.$pushNotification.error("Not found sellerId");
    }
    try {
      this.loadingTable = true;
      const response = await this.$api.userPaymentAdmin.listPaymentSeller(
        this.sellerId
      );
      if (response) {
        const findPaypal = response.data.find(
          (payment: any) => payment.type === "paypal"
        );
        const findStripe = response.data.find(
          (payment: any) => payment.type === "stripe"
        );
        if (findPaypal) {
          this.listPaymentSeller.forEach((payment: any) => {
            if (payment.type === "paypal") {
              payment.name = findPaypal.paymentId.name;
              payment.type = "paypal";
              payment._id = findPaypal._id;
            }
          });
        } else {
          this.listPaymentSeller.forEach((payment: any) => {
            if (payment.type === "paypal") {
              payment.name = "";
              payment.type = "paypal";
              payment._id = "";
            }
          });
        }
        if (findStripe) {
          this.listPaymentSeller.forEach((payment: any) => {
            if (payment.type === "stripe") {
              payment.name = findStripe.paymentId.name;
              payment.type = "stripe";
              payment._id = findStripe._id;
            }
          });
        } else {
          this.listPaymentSeller.forEach((payment: any) => {
            if (payment.type === "stripe") {
              payment.name = "";
              payment.type = "stripe";
              payment._id = "";
            }
          });
        }
      }
      // this.$store.dispatch("adminUsers/onGetListPayment", {
      // 	ctx: this,
      // 	sellerId: this.sellerId,
      // });
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onGetListStore() {
    try {
      this.loadingTable = true;
      this.configStore.sellerId = this.sellerId;
      this.$store.dispatch("adminUsers/onGetStoreSeller", {
        ctx: this,
        query: this.configStore,
      });
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  openDialogAddPayment(payment: any) {
    this.dialogAddPayment = true;
    this.config.type = payment.type;
    this.userPaymentId = payment;
    this.onGetListPayment();
  }

  closeDialogAddPayment() {
    this.dialogAddPayment = false;
  }

  async onAddPayment() {
    try {
      this.loading = true;
      const body = {
        paymentId: this.paymentId,
        listSellerId: [this.sellerId],
      };
      await this.$api.payment.attach(body);
      this.$pushNotification.success("Payment gateway update successful");
      this.paymentId = "";
      this.dialogAddPayment = false;
      this.onGetListPaymentSeller();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  openDialogDelete(userPaymentId: string) {
    this.userPaymentId = userPaymentId;
    this.dialogRemovePayment = true;
  }

  async onDeletePayment() {
    try {
      this.loading = true;
      await this.$api.payment.deleteUserPayment(this.userPaymentId._id);
      this.$pushNotification.success("Delete payment successfully");
      this.dialogRemovePayment = false;
      this.onGetListPaymentSeller();
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  onRedirectPage() {
    this.configStore.page = this.pageStore;
    this.onGetListStore();
  }

  async onChangeStatus(store: any) {
    try {
      const body = {
        storeId: store._id,
        status: store.isActive ? "active" : "close",
      };
      await this.$api.storeAdmin.changeStatus(body);
      this.$pushNotification.success("Update status successfully");
      this.onGetListStore();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  @Watch("configStore.page")
  changedPage() {
    this.onGetListStore();
  }
}
</script>

<style></style>
